let prt = Bunch.print_bunch Interpreter.printclause

let argn = ref 1

let fname = ref "test.bi"

let copyright = "\n** Copyright (c) Pablo Armelin 2001 **\n\n"

let flag = ref false

let fn () = 
  let t = ref (Interpreter.readfile !fname)
  and s = ref ""
  in
      Interpreter.setdebug !flag;
      while true do
	  prt !t;
	  print_string " ?- ";
	  s := read_line();
	  begin match !s with 
	      "\f" ->
		  print_string "filename: ";
		  fname := read_line();
		  t := Interpreter.readfile !fname;
	    | "exit" ->
		  raise Interpreter.End
	    | _ ->
		  Interpreter.prove !t (Interpreter.readgoal !s)
	  end
      done

let rec f() = 
  try fn() with 
    Interpreter.Finished -> f()
  | Stream.Failure -> f()
  | Interpreter.Failed p -> print_string "Failed with "; prt p; 
	print_string "\n"; f()
  | Interpreter.End -> print_string "bye\n"
  | Sys_error _ -> fname := "i.bi"; f()

let vhelp = "\t-v\t\tprint proof derivation\n"

let thelp = "\t-f <filename>\tuse <filename> as input\n"

let help = "usage: blp [-v] [-f <filename>]\n"^vhelp^thelp

let print_help () = print_string help; exit(1)

let start() = 
  let length = Array.length(Sys.argv) in
  if length > 4 then print_help()
  else if length > 1 then
      try begin
      while !argn < length do
	  match Sys.argv.(!argn) with
	      "-v" -> flag := true; argn := !argn+1
	    | "-f" -> fname := Sys.argv.(!argn+1); argn := !argn+2;
	    | _ -> print_help()
      done
      end
      with Invalid_argument _ -> print_help()
  else ();
  print_string copyright;
  f();;

start();;
