exception BunchErrorException
exception BunchMatchException

type 'a bunch = 
    Empty
  | L of 'a
  | MB of 'a bunch list 
  | AB of 'a bunch list 

type 'a node = 
    Leaf of 'a | Add | Mul 
  | End | OBracket | CBracket

val mjoin : 'a bunch -> 'a bunch -> 'a bunch
val ajoin : 'a bunch -> 'a bunch -> 'a bunch
val arity : 'a bunch -> int list
val proc : ('a -> 'b bunch) -> 'a bunch -> 'b bunch 
val bmap : ('a -> 'b) -> 'a bunch -> 'b bunch
val bzip : 'a bunch -> 'b bunch -> ('a * 'b) bunch
val biter : ('a -> unit) -> 'a bunch -> unit
val bexists : ('a -> bool) -> 'a bunch -> bool
val mem : 'a -> 'a bunch -> bool
val subbunch : 'a bunch -> 'a bunch -> bool
val intersection : 'a bunch -> 'a bunch -> 'a bunch
val check : 'a bunch -> 'a bunch -> bool
val remfirst : 'a -> 'a bunch -> 'a bunch
val mnw : 'a -> 'a bunch -> 'a bunch
val subtract : 'a bunch -> 'a bunch -> 'a bunch
val getabunch : 'a -> 'a bunch -> 'a bunch
val replace : 'a bunch -> 'a -> 'a bunch -> 'a bunch
val build_bunch : 'a node Stream.t -> 'a bunch
val print_bunch : ('a -> string) -> 'a bunch -> unit
val bunch_to_string : ('a -> string) -> 'a bunch -> string
val psb : string bunch -> unit
val make : string -> string bunch
