type symbol = Lexer.symbol

type clause = 
    Catom of term
  | Caand of clause * clause
  | Cmand of clause * clause
  | Cmimp of goal * term * int
  | Caimp of goal * term
  | Call of varbind * clause
  | Callnew of varbind * clause
and goal = 
    Gatom of term 
  | Gaand of goal * goal
  | Gmand of goal * goal
  | Gaor of goal * goal
  | Gmimp of clause * goal * bool
  | Gaimp of clause * goal
  | Gex of varbind * goal
  | Gexnew of varbind * goal
  | Gall of varbind * goal
  | Gallnew of varbind * goal
  | Gcommand of term
and term = Term.term
and varbind = Term.varbind

type cbunch = clause Bunch.bunch
type substitution = (term*term)Bunch.bunch

val readClauses : string list -> symbol Stream.t -> cbunch
val readVariables : symbol Stream.t -> varbind Bunch.bunch
val readClause : string list -> symbol Stream.t -> clause
val readGoal : string list -> symbol Stream.t -> goal
val openFile : string -> symbol Stream.t

val read_clauses : string -> cbunch
val read_goal : string -> goal

val printClause : substitution -> clause -> string
val printGoal : substitution -> goal -> string
