type tag = Add | Mul

type term = 
    Bvar of string
  | Evar of tag*string*int*string
  | Const of string
  | Appl of string * (term Bunch.bunch)
and varbind = Varbind of string

type substitution = (term * term) Bunch.bunch

val readTerm : string list -> string -> Lexer.symbol Stream.t -> term
val printTerm : substitution -> term -> string
val printTerm1 : substitution -> term -> string
val printSubst : term Bunch.bunch -> substitution -> unit
val dereference : term -> (term * term) Bunch.bunch -> term
val subst : term -> varbind -> term -> term
val unify :  term -> term -> (substitution -> unit) -> substitution -> unit
val findbyname : string -> substitution -> term
val project_substitution :
  term Bunch.bunch -> (term * term) Bunch.bunch -> (term * term) list 
