#load "bunch.cmo"
#load "lexer.cmo"
#load "term.cmo"
#load "parser.cmo"
#load "interpreter.cmo"

exception End

let prt = Bunch.print_bunch Interpreter.printclause

let copyright = "Copyright (c) Pablo Armelin 2001\n"

let fname = ref "test.bi"

let flag = ref false

let fn () = 
  let t = ref (Interpreter.readfile !fname)
  and s = ref ""
  in
      Interpreter.setdebug !flag;
      while true do
	  prt !t;
	  print_string " ?- ";
	  s := read_line();
	  begin match !s with 
	      "\f" ->
		  print_string "filename: ";
		  fname := read_line();
		  t := Interpreter.readfile !fname;
	    | _ ->
		  Interpreter.prove !t (Interpreter.readgoal !s)
	  end
      done

let rec f() = 
  try fn() with 
    Interpreter.Finished -> f()
  | Stream.Failure -> f()
  | Interpreter.Failed p -> print_string "Failed with "; prt p; 
	print_string "\n"; f()
  | Interpreter.End -> print_string "bye\n"
  | Sys_error _ -> fname := "i.bi"; f()

let start() = print_string copyright; f()

